//
//  event_emitter.h
//  ldb
//
//  Created by Wang Liang on 2017/10/1.
//

#ifndef event_emitter_h
#define event_emitter_h

#include "hi-node.h"
#include <list>
#include <map>

class EventEmitter {
private:
    class EventListener {
    public:
        bool once;
        Nan::Callback *callback;
        
        EventListener(const Local<Function>& callback, const bool once = false);
        
        ~EventListener();
        
        void Release();
    };
    
    map<string, list<EventListener*>> _events;
    
    node::ObjectWrap *_parent;
    
public:
    
    EventEmitter(node::ObjectWrap *parent);
    
    ~EventEmitter();
    
    bool On(const string& type, const Local<Value>& callback, const bool once = false);
    
    void Un(const string& type, const Local<Function>& callback);
    
    void Emit(const string& type, int argc, Local<Value> argv[]);
    
    bool HasListener(const string& type);
    
};




#endif /* event_emitter_h */
