//
//  ldb_batch.h
//  binding
//
//  Created by Wang Liang on 2017/9/11.
//
//

#ifndef ldb_batch_h
#define ldb_batch_h

#include "hi-node.h"
#include <list>

#include "leveldb/write_batch.h"

namespace Ldb {
    
    
    class Data {
    public:
        enum Type {
           Del, Put, Cache, Append, Remove
        };
        Type type;
        string key;
        string value;
        Data(const Type type, const string& key, const string& value) {
            this->type = type;
            this->key  = key;
            this->value = value;
        }
    };
    
    
    
    class Batch {
    public:
        
//        class Data {
//        public:
//            const string type;
//            const string key;
//            const string value;
//            const bool append;
//            Data(const string& type, const string& key, const string& value, const bool append=false);
//        };
        
        list<Data> datas;
        
        void Add(const Local<Value>& data);
        
        void AddByArray(const Local<Array>& data);
        
        void AddByObject(const Local<Object>& data);
        
        void Put(const string& key, const string& value, const bool append=false);
        
        void Del(const string& key);
        
        leveldb::WriteBatch* Export();

    };
    
}


#endif /* ldb_batch_h */

