//
//  ldb_iterator.h
//  binding
//
//  Created by Wang Liang on 2017/9/5.
//
//

#ifndef ldb_iterator_h
#define ldb_iterator_h

#include "hi-node.h"
#include "leveldb/db.h"

namespace Ldb {
    
    
    class Ldb;
    
    class HI_CLASS(Iterator) {
    private:
        uint8_t _status;
        
        
        leveldb::ReadOptions* _readOpt;
        leveldb::Iterator* _iterator;
        Nan::Callback* _callback;
    
        string _opt_keyStart;
        string _opt_keyEnd;
        string _opt_prefix;
        string _opt_prefixEnd;
        int32_t _opt_limit;
        bool _opt_reverse;
        bool _opt_snapshot;
        
    public:
    
        Ldb* ldb;
        
        string currentKey;
        
        string currentValue;
    
        ~Iterator();
        
        bool IsInited();
        
        bool IsValid();
        
        bool IsEnd();
        
        void Init();
        
        void Release();

        bool Read();
        
        bool Call();
        
        static string NextKey(const string& key);
        
        static string PrevKey(const string& key);
        
        static Local<Object> NewInstance(Ldb* ldb, const Local<Value>& opt, Nan::Callback *callback);
        
        HI_CLASS_DEFINE(Iterator);
        static HI_GETTER(jsGetterKey);
        static HI_GETTER(jsGetterValue);
        static HI_GETTER(jsGetterText);
        static HI_GETTER(jsGetterIsEnd);
        static HI_METHOD(jsRead);
        static HI_METHOD(jsAsyncRead);
        static HI_METHOD(jsBreak);
    };

}

#endif /* ldb_iterator_h */

